package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFUserGroupDetailMapper;
import com.sa.ibiz.demo.demo.domain.WFUserGroupDetail;
import com.sa.ibiz.demo.demo.service.WFUserGroupDetailService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFUserGroupDetailSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFUserGroupService;
import com.sa.ibiz.demo.demo.service.WFUserService;

/**
 * 实体[WFUserGroupDetail] 服务对象接口实现
 */
@Service
public class WFUserGroupDetailServiceImpl extends ServiceImplBase<WFUserGroupDetailMapper, WFUserGroupDetail> implements WFUserGroupDetailService{

    @Autowired
    private WFUserGroupService wfusergroupService;
    @Autowired
    private WFUserService wfuserService;

    @Resource
    private WFUserGroupDetailMapper wfusergroupdetailMapper;


    @Override
    public boolean create(WFUserGroupDetail et) {
        this.beforeCreate(et);
        String primaryKey=et.getWfusergroupdetailid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setWfusergroupdetailid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public WFUserGroupDetail get(WFUserGroupDetail et) {
        String primaryKey=et.getWfusergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setWfusergroupdetailid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(WFUserGroupDetail et) {
        String primaryKey=et.getWfusergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setWfusergroupdetailid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(WFUserGroupDetail et){
        String primaryKey=et.getWfusergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setWfusergroupdetailid(primaryKey);
          }
		     this.wfusergroupdetailMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(WFUserGroupDetail et){
		return et.getWfusergroupdetailid();  
    }

    @Override
    public boolean getDraft(WFUserGroupDetail et)  {
    if((!StringUtils.isEmpty(et.getWfusergroupid())) && et.getWfusergroup() == null){
            try {
                et.setWfusergroup(wfusergroupService.getById(et.getWfusergroupid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfuserid())) && et.getWfuser() == null){
            try {
                et.setWfuser(wfuserService.getById(et.getWfuserid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFUserGroupDetail> listDefault(WFUserGroupDetailSearchFilter filter) {
		return wfusergroupdetailMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFUserGroupDetail> searchDefault(WFUserGroupDetailSearchFilter filter) {
		return wfusergroupdetailMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfusergroupdetailMapper.selectRow(sql);
    }

 }